package com.huawei.nlp.demo;

import com.huawei.nlp.client.MtClient;
import com.huawei.nlp.client.auth.AuthInfo;
import com.huawei.nlp.client.auth.AuthMode;
import com.huawei.nlp.client.exception.NlpException;
import com.huawei.nlp.restapi.model.LanguageDetectionReq;
import com.huawei.nlp.restapi.model.LanguageDetectionResp;
import com.huawei.nlp.restapi.model.TextTranslateReq;
import com.huawei.nlp.restapi.model.TextTranslateResp;

public class MtDemo {

    /**
     * 以下参数为例子，不能直接正常使用，需用户替换为自己的参数
     * ak 用户自己的ak
     * sk 用户自的sk
     * serviceRegion 用户所在的服务区域，cn-north-4表示北京四
     * projectId 用户自己的项目id，参考官网获取教程
     */
    private static AuthInfo authInfo = new AuthInfo("QTWAOYTTINDUT2QVKYUC","MFyfvK41bM7Uio6PznpdUKGpownRZmHc",
        "cn-north-4","MFyfvK43s1ba2giqM7Uio6PznpdUKGpownRZm22Hc");
    private static MtClient mtClient = new MtClient(AuthModeAKSK,authInfo);

    /**
     * 文本翻译例子
     */
    public static void translateDemo() {
        TextTranslateReq req = new TextTranslateReq();
        //待翻译内容
        req.setText("来一首周杰伦的青花瓷");
        //源文本语种，zh表示中文，auto表示自动识别
        req.setFrom("zh");
        //目标文本语种，en表示英语
        req.setTo("en");
        //选填，表示使用场景，目前只支持common。
        req.setScene("common");
        try {
            TextTranslateResp resp = mtClient.translateText(req);
        } catch (NlpException e) {
            //失败统一以异常形式抛出，详情见异常类说明。客户端自行处理异常
            e.printStackTrace();
        }
    }

    /**
     * 语种识别例子
     */
    public static void detectLanguageDemo() {
        LanguageDetectionReq req = new LanguageDetectionReq();
        //待识别语种内容
        req.setText("来一首周杰伦的青花瓷");

        try {
            LanguageDetectionResp resp = mtClient.detectLanguage(req);
        } catch (NlpException e) {
            //失败统一以异常形式抛出，详情见异常类说明。客户端自行处理异常
            e.printStackTrace();
        }
    }

    /**
     * Main函数
     */
    public static void main(String []args) {
        MtDemo.detectLanguageDemo();
        MtDemo.translateDemo();
    }

}
